#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    uint32_t N, Q, L, R, res;

    cin >> N >> Q;

    uint32_t A[N];
    for(uint32_t i = 0; i < N; i++) cin >> A[i];

    for( ; Q--;){
        cin >> L >> R;

        res = A[L - 1];

        for(uint32_t j = L; j < R; j++) res &= A[j];

        cout <<  res << "\n";
    }
}